part of spark;

/// theme widget builder
typedef WidgetThemeBuilder = Widget Function(
    BuildContext context, SparkTheme theme);

enum FormStrategy {
  /// form change strategy, if validate error, back to old value
  limit,

  /// just tip error message
  tip,

  /// Not to do anything
  noop,
}

typedef TagGroupItemBuilder = Widget Function(
  BuildContext context,
  SparkTagGroupItem data,
);

typedef TagGroupItemIconBuilder = Positioned Function(
  BuildContext context,
  bool selected,
);

/// form append widget builder
/// [widget] is widget cache
typedef AppendChildBuilder<T> = Widget? Function(
  BuildContext context,
  T value,
  Widget? widget,
);

/// validate function
typedef ValidateCallback = ValidateResult Function(
    dynamic value, VerifyType type);

/// updater
typedef ValueUpdater<T> = void Function(T value);

typedef Updater = void Function();

/// custom form widget builder
/// [value] is form item field value, that call on [value] change
/// [updater] value's updater, receive new [value] and update widget builder
typedef FormItemWrapperBuilder = Widget Function(
  BuildContext context,
  dynamic value,
  ValueUpdater updater,
);

/// spark select item options builder
/// [SparkSelect]
typedef ItemValueBuilder = Widget Function(
  BuildContext context,
  SparkOption value,
  SparkSelectDecoration decoration,
);

/// check string is empty
bool emptyOrNullString(String? value) {
  return value == null || value == '';
}

List<DateTime> getDateRange(int beforeYear, int afterYear) {
  DateTime _now = DateTime.now();
  return [
    DateTime(_now.year - beforeYear, _now.month, _now.day),
    DateTime(_now.year + afterYear, _now.month, _now.day, 23, 59, 59),
  ];
}
